#include "project.h"

#define BMP180_MODULE_ADDRESS                0x77    // BMP180 I2C address
#define OSS                                  0x03    //Oversampling setting for ultra high resolution

typedef struct {
    short AC1;
    short AC2;    
    short AC3;
    unsigned short AC4;
    unsigned short AC5;
    unsigned short AC6;
    short B1;
    short B2;
    short MB;
    short MC;
    short MD;
    
}BMP180_CALIBRATION_DATA;

void BMP180Init(void);
BMP180_CALIBRATION_DATA makeBMPCalibrationTable(void);
BMP180_CALIBRATION_DATA makeCalibrationData(uint8 * dBuffer);
long BMP180_Read_UT(void); 
long BMP180_Read_UP(void);
long calculateTrueTemp(long UT, BMP180_CALIBRATION_DATA calibration);
long BMP180GetTemperature(BMP180_CALIBRATION_DATA calibration);
long BMP180GetPreassure(BMP180_CALIBRATION_DATA calibration);

/* [] END OF FILE */