/*******************************************************************************
* File Name: DHT22_Data.h  
* Version 2.20
*
* Description:
*  This file contains the Alias definitions for Per-Pin APIs in cypins.h. 
*  Information on using these APIs can be found in the System Reference Guide.
*
* Note:
*
********************************************************************************
* Copyright 2008-2015, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_DHT22_Data_ALIASES_H) /* Pins DHT22_Data_ALIASES_H */
#define CY_PINS_DHT22_Data_ALIASES_H

#include "cytypes.h"
#include "cyfitter.h"
#include "cypins.h"


/***************************************
*              Constants        
***************************************/
#define DHT22_Data_0			(DHT22_Data__0__PC)
#define DHT22_Data_0_PS		(DHT22_Data__0__PS)
#define DHT22_Data_0_PC		(DHT22_Data__0__PC)
#define DHT22_Data_0_DR		(DHT22_Data__0__DR)
#define DHT22_Data_0_SHIFT	(DHT22_Data__0__SHIFT)
#define DHT22_Data_0_INTR	((uint16)((uint16)0x0003u << (DHT22_Data__0__SHIFT*2u)))

#define DHT22_Data_INTR_ALL	 ((uint16)(DHT22_Data_0_INTR))


#endif /* End Pins DHT22_Data_ALIASES_H */


/* [] END OF FILE */
