#include <device.h>
#include "DHT22.h"
#include "BMP180.h"
#include <stdio.h>   				/* sprintf() */
#include "Data_and_Func.h"

#define SAMPLE_SIZE     10
#define SSID "MEZON-B310-8427" 				
#define PASS "8HL9580TGJ2" 			    

int i=0;

//CY_ISR_PROTO(WIFI_Reconnect);
//CY_ISR(Reconnect)
//	{ recon++; }

//------------------------------------------------------------------------------------------------------
int main()
    { 
    DHT22_ErrorCode res;
    BMP180_CALIBRATION_DATA BMP180_calibration;
    uint16_t temperature, humidity;
    uint16_t temperature_array[SAMPLE_SIZE]; 
    uint16_t humidity_array[SAMPLE_SIZE];
    uint16_t average_temperature = 0;
    uint16_t average_humidity = 0;
    long BMP180_temperature;
    long BMP180_preassure;
    char message[50];
    int i;    
    //char Rxbyte[10]={0};
    //char data[32];
    
    CyGlobalIntEnable;				/* Enable all interrupts by the processor. */
    RST_Write(LOW);
    UART_Start();
    UART_1_Start();
    UART_1_UartPutString("BUG the DEBUG! (257 bytes for uart) ^_^ \r\n");
    
do{
    UART_PutString("AT+CWMODE=1\r\n"); 
    //UART_1_UartPutString("Send AT+CIFSR \r\n");
    UART_PutString("Connecting to wifi!\r\n");   
}while(!WaitText("ready", 1000));

UART_1_UartPutString("WELCOME\r\n");
CyDelay(1000);

BMP180Init();

UART_1_UartPutString("BMP180 initialised!\r\n");

CyDelay(1000);  // Wait for DHT22 to power up
    
    UART_1_UartPutString("Quering for BMP180 calibration data...\r\n");
    
    BMP180_calibration = makeBMPCalibrationTable();
    
    UART_1_UartPutString("Calibration data received!\r\n");    
    UART_1_UartPutString("Receiving data from DHT22\r\n");
    
    res = DHT22_Read(&temperature, &humidity); // skip first data point
    
    for(i=0;i<SAMPLE_SIZE;i++){
            res = DHT22_Read(&temperature, &humidity);
            
            while(res != DHT22_OK) {
               res = DHT22_Read(&temperature, &humidity);
            }
        
        temperature_array[i] = temperature/100; 
        humidity_array[i] = humidity/100; 
         
        sprintf(message,"DHT22 AVG_Temp[%d]: %d, AVG_HMD[%d]: %d\r\n",i,temperature_array[i],i,humidity_array[i]);
        UART_1_UartPutString(message);
        
        CyDelay(DHT22_SAMPLE_PERIOD);
    }
     
    UART_1_UartPutString("Data received!\r\n");
    
        for(i=0;i<SAMPLE_SIZE;i++){
            average_temperature += temperature_array[i];
            average_humidity += humidity_array[i];
        }

    UART_1_UartPutString("Averaging the received data\r\n");    
        
    average_temperature = average_temperature / SAMPLE_SIZE; 
    average_humidity = average_humidity / SAMPLE_SIZE;
    
    UART_1_UartPutString("Data received!\r\n");
    memset(message,0,50);
    sprintf(message,"DHT22 AVG_Temp: %d, AVG_HMD: %d\r\n",average_temperature, average_humidity);
    UART_1_UartPutString(message);    
    UART_1_UartPutString("Receiving BMP180 data...\r\n");
    
    BMP180_temperature = BMP180GetTemperature(BMP180_calibration);
    BMP180_preassure = BMP180GetPreassure(BMP180_calibration);
    
    //memset(message,0,50);
    sprintf(message,"BMP180 Temp: %d, Pres: %d\r\n",average_temperature, average_humidity);
    UART_1_UartPutString(message); 
    
    UART_PutString("AT\r\n"); 
    
    CyDelay(100);
    
    if (!WaitText("OK", 1000)) 
        UART_1_UartPutString("UART does not work\r\n");
    else
        UART_1_UartPutString("Uart works! \r\n");

/*
while(1)
{
    ch = UART_GetChar(); 
        if(0u != ch)
        {
            Rxbyte[i]=ch; 
          sprintf(data,"\n value:%x\n\r",Rxbyte[i]); 
            UART_1_UartPutString(data);
            UART_1_UartPutCRLF(ch);
    
        }
        CyDelay(5000);

}
*/



// ****************try to connect to wifi ********************************************
CyGlobalIntDisable;
for(i=0;i<10;i++){
memset(message,0,50);
sprintf(message,"Connecting... (try number %d)\r\n",i+1);

UART_1_UartPutString(message);
if(connectWiFi(SSID, PASS)){ 
    UART_1_UartPutString("WiFi Connected!! \r\n");
    break;
} 
CyDelay(6000); 
}
if (i==10) 
{
    UART_1_UartPutString( "WiFi has not connected after 10 tries...\r\n");
    CyDelay(3000);
    RST_Write(HIGH);
    CySoftwareReset();
}	
CyGlobalIntEnable;
//------------------------------------------------------------------------------------------------
/*
IP_to_LCD();			// IP - на экран LCD
SetServer(8045);		// включаем сервер на порт  8046 ( или какой вам удобно)
CyDelay(500);
UART_ClearRxBuffer();	// начнем жизнь с нового листа ))

while(1)
  { 								
	if (WaitText("GET", 500))						// ждем запрос GET от клиента
    	{
 		CyDelay(50);								// "GET" получен, подождем пока закончится передача
		webserver();								// отвечаем и закрываем соединение
		recon=0;									// сброс счетчика профилактической перезагрузки
		}
	if(recon==60) 	
    {
        recon=0; 
        CySoftwareReset ();
    }	// скучно ...  перезагрузимся для профилактики зависания ESP8266 )))
  }
 */
}
/* 
[] END OF FILE
*/
    
